require 'pathname'
require 'shellwords'
require 'logger'
require 'securerandom'
require 'digest/sha2'
require 'pdf_service/error'
require 'pdf_service/config'
require 'pdf_service/utils/tempfile_service'
require 'pdf_service/utils/null_logger'
require 'pdf_service/phantom_js_renderer'
require 'pdf_service/service'


module PDFService
  ROOT_PATH = Pathname(__FILE__).dirname
  DefaultConfiguration = Config.new


  def self.with_config(config)
    Service.new(Config[config])
  end

  def self.render(html)
    with_config(DefaultConfiguration).render(html)
  end
end