module PDFService
  class Service
    def initialize(config)
      @tempfiles = Utils::TempfileService.new(root: config.tmp_path).freeze
      @renderer = PhantomJSRenderer.new(logger: config.logger).freeze
    end

    attr_reader :tempfiles
    attr_reader :renderer

    def render(html)
      tempfiles.use(extension: 'html') { |input_file|
        input_file.write(html)
        render_url("file://#{input_file.expand_path.to_s.strip}")
      }
    rescue Error => ex
      raise ex
    rescue => ex
      raise Error.new(ex)
    end

    def render_url(url)
      tempfiles.use(extension: 'pdf') { |output_file|

        renderer.rasterize(url, output_file.expand_path.to_s)

        return output_file.read
      }
    rescue Error => ex
      raise ex
    rescue => ex
      raise Error.new(ex)
    end
  end
end