module PDFService
  module Utils
    class TempfileService
      def initialize(root: Pathname('.'))
        @root = Pathname(root)
      end

      def use(name: SecureRandom.hex, extension: 'tmp')
        path = Pathname('.').expand_path.join("#{name}.#{extension}")
        yield(path)
      ensure
        path.unlink if path.exist?
      end
    end
  end
end